package net.sourceforge.jetris;

import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

public class Level {
	
	@Override
	public String toString() {
		String startGridStr="", goalGridStr="";
		
		for (int y=0; y<this.height; y++) {
			for (int x=0; x<this.width; x++) {
				startGridStr += (startGrid[x][y] == null ? "?" : (startGrid[x][y] ? "1" : "0")) + " ";
				goalGridStr += (goalGrid[x][y] == null ? "?" : (goalGrid[x][y] ? "1" : "0")) + " ";
			}
			startGridStr += '\n';
			goalGridStr += '\n';
		}
			
		
		
		return "Level [width=" + width + ", height=" + height + ", steps="
				+ steps + ", startGrid=\n" + startGridStr
				+ ", goalGrid=\n" + goalGridStr + ", objSeq="
				+ objSeq + "]";
	}

	private int width;
	private int height;
	private int steps;
	
	private Boolean[][] startGrid;
	private Boolean[][] goalGrid;
	
	private List<Figure> objSeq;
	
	private List<Action> solution = new LinkedList<Action>();
	
	public List<Action> getSolution() {
		return solution;
	}

	public void setSolution(List<Action> solution) {
		if (solution==null) 
			this.solution = new LinkedList<Action>();
		else 
			this.solution = solution;
	}

	public Level() {
		this(0,0,null, null, null, 0);		
	}

	public Level(int width, int height, Boolean[][] startGrid,
			Boolean[][] goalGrid, List<Figure> objSeq, int steps) {
		super();
		this.width = width;
		this.height = height;
		this.startGrid = startGrid;
		this.goalGrid = goalGrid;
		this.objSeq = objSeq;
		this.steps = steps;
	}

	public int getWidth() {
		return width;
	}

	public void setWidth(int width) {
		this.width = width;
	}

	public int getHeight() {
		return height;
	}

	public void setHeight(int height) {
		this.height = height;
	}

	public Boolean[][] getStartGrid() {
		return startGrid;
	}

	public void setStartGrid(Boolean[][] startGrid) {		
	    int rows=startGrid.length ;
	    this.startGrid =(Boolean[][]) startGrid.clone();
	    
	    for(int row=0;row<rows;row++){
	        this.startGrid[row]=(Boolean[]) startGrid[row].clone();
	    }	
	}

	public Boolean[][] getGoalGrid() {
		return goalGrid;
	}

	public void setGoalGrid(Boolean[][] goalGrid) {
	    int rows=goalGrid.length ;
	    this.goalGrid =(Boolean[][]) goalGrid.clone();
	    
	    for(int row=0;row<rows;row++){
	        this.goalGrid[row]=(Boolean[]) goalGrid[row].clone();
	    }	
	}

	public List<Figure> getObjSeq() {
		return objSeq;
	}

	public void setObjSeq(List<Figure> objSeq) {
		this.objSeq = objSeq;
	}

	public void setSteps(int steps) {
		this.steps = steps;
	}

	public int getSteps() {
		return steps;
	}
}
